/*!
  spica javascript libraries - buildprogress.js
  == written by Takuya Otani <takuya.otani@gmail.com> ===
  == Copyright (C) 2006 SimpleBoxes/SerendipityNZ Ltd. ==
*/

// [guideline]
// -- http://serennz.sakura.ne.jp/guidelines/js_en_000.txt
// -- http://serennz.sakura.ne.jp/guidelines/js_ja_000.txt

// ver 0.00 [2008/11/01] the first attempt

Spica.Library.require('ajax','element');
Spica.BuildProgress = function(serverUrl)
{
	this.initialized = false;
	this.started = false;
	this.timer = null;
	this.num = 0;
	this.max = 0;
	this.server = serverUrl;
	return this;
};
Spica.BuildProgress.prototype = {
	doTest : function()
	{
		var self = this;
		if (self.initialized) return;
		var ajax = new Spica.Ajax();
		if (!ajax)
		{ // just set a flag
			self.initialized = true;
			return;
		}
		ajax.onerror  = function() {}; // do nothing
		ajax.callback = function(response) { self.doneTest(response) };
		ajax.get(self.server + '?__rebuild=-1',null);
	},
	doneTest : function(response)
	{
		var self = this;
		self.initialized = true;
		if (!response) return;
		var res = response.getElementsByTagName('result');
		if (!res.length || !res[0].firstChild.nodeValue || res[0].firstChild.nodeValue != 1) return;
		Spica.$('rebuild_option').options.length = 2;
		Spica.Event.register(Spica.$('submit'),'click',function(evt) { self.onSubmit(evt) });
	},
	onSubmit : function(evnt)
	{
		var self = this;
		evnt = (evnt) ? evnt : ((window.event) ? event : null);
		if (Spica.$('rebuild_option').options[0].selected)
		{
			self.doBuild();
			return Spica.Event.stop(evnt);
		}
	},
	doBuild : function()
	{
		var self = this;
		if (self.max == 0) return false; // do nothing
		if (!self.started)
		{
			Spica.$('rebuildOptionField').style.display = 'none';
			Spica.$('rebuildStatusField').style.display = 'block';
			self.started = true;
		}
		var ajax = new Spica.Ajax();
		if (!ajax) return false;
		ajax.onerror  = function() {}; // do nothing
		ajax.callback = function(response) { self.doneBuild(response) };
		ajax.get(self.server + '?__rebuild=' + self.num,null);
	},
	doneBuild : function(response)
	{
		var self = this;
		if (!response) return self.showMessage(Spica.$_('No content error.'));
		var result = response.getElementsByTagName('result');
		if (!result.length) return self.showMessage(Spica.$_('No result error.'));
		var check = result[0].firstChild.nodeValue;
		if (self.num > self.max) return self.showMessage(Spica.$_('Unknown error.'));
		if (check == 1)
		{
			self.showMessage('');
			self.num++;
			if (self.timer) window.clearTimeout(self.timer);
			self.timer = window.setTimeout(function() { self.doBuild(); }, 100);
		}
		else
		{ // check != 1
			self.showMessage('<strong>' + Spica.$_(check) + '</strong>');
			if (check == 'completed')
			{
				Spica.$('explainComplete').style.display = 'block';
				Spica.$('explainProgress').style.display = 'none';
			}
		}
	},
	showMessage : function(message)
	{
		var self = this;
		var progress = Spica.$('rebuildProgress');
		if (progress && Spica.DOM.getParent(progress))
		{
			var width = Spica.DOM.getParent(progress).clientWidth;
			if (message == '') width *= (self.num / self.max);
			progress.style.width = Math.floor(width) + 'px';
		}
		if (message == '')
			message = Math.floor((self.num / self.max) * 100) + ' %';
		if (!progress)
			alert(message);
		else
			progress.innerHTML = message;
		return;
	}
};
